#include "iom48.h"
#include "ina90.h"


//Key   ̷  .
//Normal Mode					Mode=0  
//EEPROM Writing			Mode=1  
//Power Down Mode			Mode=2  
//Wake_up(Normal Mode)Mode=0  
//EEPROM Writing			Mode=1
//Power Down Mode			Mode=2

unsigned char Key;
unsigned char Mode;

void INIT(void)
{
	DDRB = 0x00;	PORTB = 0xFF;
	DDRC = 0x00;  PORTC = 0xFF;
	DDRD = 0x00;  PORTD = 0xFF;
	ACSR |= (1<<ACD);
	SMCR = (1<<SM1)|(1<<SE);
	PRR = (1<<PRTWI)|(1<<PRTIM2)|(1<<PRTIM0)|(1<<PRTIM1)|(1<<PRSPI)|(1<<PRUSART0)|(1<<PRADC);
    EIMSK=(1<<INT0);                //External Interrupt Request 0 Enable
}

void EEPROM_write(unsigned int uiAddress, unsigned int ucData )
{
  // Wait for completion of
  while(EECR & (1<<EEPE));
  // Set up address and Data
  EEAR = uiAddress;
  EEDR = ucData;
  // Write logical one to EEMPE
  EECR |= (1<<EEMPE);
  // Start eeprom write by setting
  EECR |= (1<<EEPE);
}


void NormalMode(void) 
{
		asm("nop");
}


void WriteEeprom(void)
{
	unsigned char i;
	for(i=0;i<255;i++) EEPROM_write(i,i);
	Mode=2;
	SMCR = (1<<SM1)|(1<<SE);
}

void SleepMode(void)
{
	asm("sleep");
}

void main(void)
{
	INIT();
	_SEI();
	while(1)
	{
		switch(Mode) {
			case 0:
						NormalMode();
						break;
			case 1:
						WriteEeprom();
						break;
			case 2:
						SleepMode();
						break;
			default : break;
		}
  }
}



#pragma vector=INT0_vect
__interrupt void INT0_isr(void)
{
		if((EICRA&0x03) == 0) {
  		 EICRA = (1<<ISC01)|(1<<ISC00);	//Rising Edge
  		 SMCR = 0;
  		 while(!PIND_Bit2);
  	}
  	else {
  		EICRA = 0x00;
  		Mode++;
  		if(Mode==3) Mode=0;
  	}
}
