#include "iom48.h"
#include "ina90.h"

#define		TESTBIT(addr,data)		addr&(1<<data)
#define		SETBIT(addr,data)		addr|=(1<<data)

unsigned int chnel=0;
unsigned int ad_value=0;

void INIT(void)
{
	DDRD=0X60;		// PORTD5,6 OUTPUT PORT(OC0B,OC0A)
	DDRC=0XFE;		// PORTC0 INPUT PORT(ADC0 INPUT)
	
	
	//////////////// --   ADC Configuration		--	///////////////////////////////
	ADMUX = (0<<REFS0)|(0<<ADLAR)|(0<<MUX0);				//AREF, Internal Vref turned off
    														//ADC Right Adjust Result   
    														//Input Channel Selections  ä 0
    														
    //		---	ADC Prescaler Selections	---	//	
    									
    //		ADPS2 ADPS1 ADPS0 	Division Factor								Nomal conversion time(13clk)
   	//		  0     0 	  0         2                1Mhz/2		= 	500khz         2us*13	= 26us 				
    //		  0     0     1         2                1Mhz/2 	= 	500khz         2us*13	= 26us								
    //		  0     1     0         4                1Mhz/4 	= 	250khz         4us*13	= 52us
    //		  0     1     1         8                1Mhz/8 	= 	125khz         8us*13	= 104us
    //		  1		0	  0 		16               1Mhz/16 	= 	62500hz        16us*13	= 208us                                                                                     
    //		  1 	0 	  1 		32               1Mhz/32 	= 	31250hz        32us*13	= 416us
    //		  1 	1	  0 		64               1Mhz/64 	= 	15625hz        64us*13	= 832us  
    //		  1 	1 	  1 		128  			 1Mhz/128 	= 	7812.5hz	   128us*13	= 1664us
       
    ADCSRA= (1<<ADEN)|(1<<ADSC)|(5<<ADPS0);	        
		
	//////////////// 	--		PWM Configuration	--	//////////////////////////////
	
	TCCR0A|=(3<<COM0A0)|(3<<COM0B0)|(1<<WGM00);  //Set OC0A on Compare Match when up-counting. Clear OC0A on Compare Match when down-counting.
												 //Set OC0B on Compare Match when up-counting. Clear OC0B on Compare Match when down-counting.
									 			 // Waveform Generation 1Mode 
									 			 
	TCCR0B=(1<<CS00);							 // clkI/O/(No prescaling)
	TCNT0=0;
	OCR0A=0x01;
	OCR0B=0X01;
}

unsigned int READ_ADC(unsigned int chnel)
{
	ADMUX|=chnel;
	ADCSRA|=SETBIT(ADCSRA,ADSC);
	while(!(TESTBIT(ADCSRA,ADIF)));
	ADCSRA|=SETBIT(ADCSRA,ADIF);
	return(ADC);
}

void main(void)
{
	INIT();
	_SEI();
	for(;;)
	{
		ad_value=READ_ADC(0);
		OCR0A=(ad_value/4);
	
	}
}