#include	"iom48.h"
#include	"ina90.h"

// 1Mhz϶...

unsigned int _10ms_cnt=0,_1sec_cnt=0;

void INIT(void)
{
	DDRB=0XFF;			//PORTB OUTPUT Configuration
	PORTB=0XFF;			//high output
	TCCR1A=0X00;
	
	//---             Clock Select Bit Description         ----------//
	//TCCR0B=(1<<CS00);		//clkI/O/(No prescaling)   			(1Mhz)     		1/(1000000/1)   = 	1us..
	//TCCR0B=(2<<CS00);		//clkI/O/8 (From prescaler)			(125000hz)		1/(1000000/8)   = 	8us..
	//TCCR0B=(3<<CS00);		//clkI/O/64 (From prescaler)		(15625hz)		1/(1000000/64)  =  	64us..
	//TCCR0B=(4<<CS00);		//clkI/O/256 (From prescaler)		(3906.25hz)		1/(1000000/256) = 	256us..
	//TCCR0B=(5<<CS00);		//clkI/O/1024 (From prescaler)		(976.5625hz)	1/(1000000/1024)= 	1024us..
	                                                                        	
	TCCR0B=(3<<CS00);		//clkI/O/64 (From prescaler)		(15625hz) 		1/(1000000/64)  = 	64us..
	TCNT0=(256-156);
	TIMSK0=(1<<TOIE0);
		
	//---             Clock Select Bit Description         ----------//
		
	TCCR1B=(1<<CS10);		//clkI/O/(No prescaling)   			(1Mhz)				1/(1000000/1)   = 	1us..
	//TCCR1B=(2<<CS10);		//clkI/O/8 (From prescaler)			(125000hz)			1/(1000000/8)   = 	8us..
	//TCCR1B=(3<<CS10);		//clkI/O/64 (From prescaler)		(15625hz)			1/(1000000/64)  =  	64us..
	//TCCR1B=(4<<CS10);		//clkI/O/256 (From prescaler)		(3906.25hz)			1/(1000000/256) = 	256us..
	//TCCR1B=(5<<CS10);		//clkI/O/1024 (From prescaler)		(976.5625hz)		1/(1000000/1024)= 	1024us..
	
	TCNT1=(65536-10000);
	TIMSK1=(1<<TOIE1);
}

#pragma vector=TIMER1_OVF_vect
__interrupt void timer1_ovf(void)
{
	TCNT1=(65536-10000);
	_10ms_cnt++;
	if(_10ms_cnt>=100)
	{
		_1sec_cnt++;
		_10ms_cnt=0;
	}
}

void main(void)
{
	INIT();
	_SEI();
	for(;;)
	{
		PORTB = ~(_1sec_cnt);
	}
}

