#include	"iom48.h"
#include	"ina90.h"

// 1Mhz϶...

unsigned int _10ms_cnt=0,_1sec_cnt=0;

void INIT(void)
{
	DDRB=0XFF;			//PORTB OUTPUT Configuration
	PORTB=0XFF;			//high output
	TCCR2A=0X00;
	
	//---             Clock Select Bit Description         ----------//
	
	//TCCR2B=(0<<CS20);		0 0 0 No clock source (Timer/Counter stopped).
	//TCCR2B=(1<<CS20);		0 0 1 clkT2S/(No prescaling)		(1Mhz)			1/(1000000/1)   = 1us..
	//TCCR2B=(2<<CS20);		0 1 0 clkT2S/8 (From prescaler)		(125000hz)		1/(1000000/8)   = 8us..
	//TCCR2B=(3<<CS20);		0 1 1 clkT2S/32 (From prescaler)	(31250hz)		1/(1000000/32)  = 32us..
	//TCCR2B=(4<<CS20);		1 0 0 clkT2S/64 (From prescaler)	(15625hz)		1/(1000000/64)  = 64us..
	//TCCR2B=(5<<CS20);		1 0 1 clkT2S/128 (From prescaler)	(7812.5hz)		1/(1000000/128) = 128us..
	//TCCR2B=(6<<CS20);		1 1 0 clkT2S/256 (From prescaler)	(3906.25hz)		1/(1000000/256) = 256us..
	//TCCR2B=(7<<CS20);		1 1 1 clkT2S/1024 (From prescaler)	(976.5625hz)	1/(1000000/1024)= 1024us..
	                                                                        	
	TCCR2B=(4<<CS20);		//1 0 0 clkT2S/64 (From prescaler)	(15625hz)		1/(1000000/64)  = 64us..
	TCNT2=(256-156);
	TIMSK2=(1<<TOIE2);
}

#pragma vector=TIMER2_OVF_vect
__interrupt void timer2_ovf(void)
{
	TCNT2=(256-156);
	_10ms_cnt++;
	if(_10ms_cnt>=100)
	{
		_1sec_cnt++;
		_10ms_cnt=0;
	}
}

void main(void)
{
	INIT();
	_SEI();
	for(;;)
	{
		PORTB = ~(_1sec_cnt);
	}
}

