
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <stdlib.h>
#include <stdio.h>

#define ADC_TYPE 0x00

unsigned char RXD;
unsigned int chnel;
unsigned int AD_value[6];

static int USART0_putchar(char c, FILE *stream);
static FILE device1 = FDEV_SETUP_STREAM(USART0_putchar, NULL, _FDEV_SETUP_WRITE);

void USART0_initialize(void)		        /* initialize USART0 */
{
  UBRR0H = 0;                                   // 19200 bps
  UBRR0L = 35;
  UCSR0A = 0x00;                                // asynchronous normal mode
  UCSR0B = 0x18;                                // Rx/Tx enable, 8 data
  UCSR0C = 0x06;                                // no parity, 1 stop, 8 data
}

static int USART0_putchar(char c, FILE *stream)	/* print a character to USART0 */
{
  if(c == '\n')                                 // process CR(carriage return)
    { loop_until_bit_is_set(UCSR0A,UDRE0);
      UDR0 = 0x0D;
      loop_until_bit_is_set(UCSR0A,UDRE0);
      UDR0 = 0x0A;
    }
  else
    { loop_until_bit_is_set(UCSR0A,UDRE0);	// Tx ready ?
      UDR0 = c;					// if yes, print
    }
  return 0;
}


//atmega48 ȯ 
void MCU_initialize(void)				
{ 
  DDRB = 0xf0;							// door PORTB = input data 
  //PORTB = 0xFF;
  
  DDRC = 0x00;							// FAN INPUT
  PORTC = 0xFF;
  
  DDRD = 0xFF;							// PORTD    ۻ 
  PORTD = 0x00;
/*
	UBRR0H = 0;                           
  	UBRR0L = 35;			            	// 143 => 4800,  35 =>19200 baud
  	UCSR0A = 0x00;                        	// asynchronous normal mode
  	UCSR0B = 0x18;                        	// Rx/Tx enable, 8 data
  	UCSR0C = 0x06;                        	// no parity, 1 stop, 8 data
  	RXD = UDR0; 
 */

}

void Delay_us(unsigned char time_us)	
{ register unsigned char i;

  for(i = 0; i < time_us; i++)			// 4 cycle +
    { asm volatile(" PUSH  R0 ");		// 2 cycle +
      asm volatile(" POP   R0 ");		// 2 cycle +
      asm volatile(" PUSH  R0 ");		// 2 cycle +
      asm volatile(" POP   R0 ");		// 2 cycle +
      asm volatile(" PUSH  R0 ");		// 2 cycle +
      asm volatile(" POP   R0 ");		// 2 cycle = 16 cycle = 1 us 
    }
}

void Delay_ms(unsigned int time_ms)	
{ register unsigned int i;

  for(i = 0; i < time_ms; i++)
    { Delay_us(250);
      Delay_us(250);
      Delay_us(250);
      Delay_us(250);
    }
}
unsigned char RX0_char_scan(void)		/* receive a character by USART0 */
{
  if((UCSR0A & 0x80) == 0x00)   		// if data not received,
    return 0x00;                                //    return with 0x00
  else                                          // if data received,
    return UDR0;                                //    return with data
}

unsigned char RX0_char(void)		        /* receive a character by USART0 */
{
  while((UCSR0A & 0x80) == 0x00);		// data received ?
  return UDR0;
}

void TX0_char(unsigned char byte)		/* 1 byte transmit a character by USART0 */
{
  while((UCSR0A & 0x20) == 0x00);		// data register empty ?
  UDR0 = byte;
}

void send(void)
{
TX0_char('\n');
TX0_char('\r');

}

void uart_string(unsigned char *str, unsigned char len)
{
	int i,j;
	for (i=0; i <len; i++)
	{
		if (!(*(str + i)))
		{
			for (j=i; j<len; j++)
			break;
		}
	TX0_char(*(str + i));
	}
}

void TX0_string(char *string)			// transmit a string by USART0 
{
  while(*string != '\0')
    { TX0_char(*string);
       string++;
    }
}

void action(void)					
{ 
  PORTD |= _BV(6);				// LED on			
  Delay_ms(500);					
  PORTD &= ~_BV(6);				// LED off
Delay_ms(500);	
}


void ADC_init(void)
{
    ADMUX=   0x47; //    adc 7pin (0<<REFS0)|(0<<ADLAR)|(0<<MUX0);											// AREF, Internal Vref turned off
    ADCSRA = 0x85; // adc enable  500khz   (1<<ADEN)|(0<<ADSC)|(0<<ADATE)|(0<<ADIF)|(0<<ADIE)|(5<<ADPS0);			// ADC Prescaler Selections = CLK / 64
								                                                   	// Trigger Source --> Free Running mode                                                             
}                                                                               	
                                                                           	
unsigned int READ_ADC(unsigned int chnel)                                       	
{                                                                               	
	ADMUX =(ADMUX&0XE0)+chnel;														// chnel select
	ADCSRA |= (1<<ADSC);															// start convert
	while(!(ADCSRA&(1<<ADIF)));														// conversion complete
	ADCSRA |= (1<<ADIF);															// Free running setting			
//
	return ADC;                                                                 	
}                                                                               	
 
/*	
void ADC_init(void)
{
	ADMUX = ADC_TYPE;
	ADCSRA =0x87;
//	SFIOR& = 0xEF;
}

unsigned int READ_ADC(unsigned int adc_in)                                       	
{                                                                               	
	ADMUX = adc_in | ADC_TYPE;														// chnel select
	ADCSRA |= 0x40;															// start convert
	while(!(ADCSRA& 0x10) == 0);														// conversion complete
	ADCSRA |= 0x10;															// Free running setting			
	return ADCW;
}
*/

int main(void)
{ 
unsigned char temp;
unsigned char temp_value;
int int_buf = 0;

unsigned char buf[5];


int  i, result;
	MCU_initialize();                    	// initialize MCU
    ADC_init();
  
   USART0_initialize(); 
  
  	Delay_ms(50);                                 
 
  sei();

 //EICRB = 0x80;                                 // INT7 = falling edge trigger
  //EIMSK = 0x80;					// enable INT7
 // EIFR = 0xFF;                                  // clear interrupt flag
 // sei();                                        // global interrupt enable
	Delay_ms(500);    

 

//	TX0_string("  uart Test OK !  ");
 
		while(1) {
		
		ADCSRA |= 0x40;
		while((ADCSRA & 0x10 ) == 0);
		result = ADCL;
		result = ADCH;
	 
int_buf += ADCL + ADCH * 256;
//itoa(result, buf, 10);
//uart_string(buf, sizeof(buf));
//	send();

// temp_value= 500 - READ_ADC(7); 
stdout = &device1;
printf("temp\n");Delay_ms(500);    
printf("temp %d\n", int_buf);Delay_ms(500);    
printf("temp %x\n", int_buf);Delay_ms(500);    
//printf("temp %b\n", temp_value);
//uart_string(temp_value, sizeof(temp_value));
//if(chnel>=5)	chnel=0; 
//else 			chnel++;


/*
   temp = PINB & 0x0f;	
if(temp == 0x01)
	 {TX0_string("OPEN DOOR ");
		 PORTD &= ~_BV(5);				//  on	
         PORTD &= ~_BV(7);
		 }
 
		action();
	RXD = RX0_char_scan();
	
	if(RXD == 'h')
	{TX0_string(" Heater ON ");
	PORTD |= _BV(7);				//  on	
	}

   if(RXD == 'p')
	{TX0_string(" Pump ON ");
	 PORTD |= _BV(5);				//  on	
	}
	
	if(RXD == 's')
	{	TX0_string(" Pump & Heater& FAN 0FF  ");
	PORTD &= ~_BV(5);				//  on	
	PORTD &= ~_BV(7);	
	}
*/

/*
	if(PORTC &= ~_BV(0))
		 {TX0_string("FAN0 ERROR");		 }
	if(PORTC &= ~_BV(1))
		 {  TX0_string("FAN1 ERROR");		 }
	if(PORTC &= ~_BV(2))
		 {  TX0_string("FAN2 ERROR");		 }
	if(PORTC &= ~_BV(3))
		 {TX0_string("FAN3 ERROR");}
	if(PORTC &= ~_BV(4))
		 {TX0_string("FAN4 ERROR");};
	if(PORTC &= ~_BV(5))
		 {TX0_string("FAN5 ERROR");}
	if(PORTC &= ~_BV(6))
		 {TX0_string("FAN6 ERROR");}
	if(PORTC &= ~_BV(7))
		 {TX0_string("FAN7 ERROR");}
*/
/*
key = PINB & 0xFF;			// key input without debouncing

if(key == 0xfe) 
	 {TX0_string("OPEN DOOR ");
		 PORTD &= ~_BV(5);				//  on	
         PORTD &= ~_BV(7);
*/		

 
	
		}
      
 } //main
















